import { u as useBagStore, s as sectionsData, _ as _imports_0, a as _sfc_main$3, b as _sfc_main$4, c as _sfc_main$5, d as _sfc_main$7, e as _sfc_main$9, f as _sfc_main$a, g as _sfc_main$b } from "./index.90306b5b.js";
import { _ as __unplugin_components_1 } from "./VControl.716059a0.js";
import { _ as _sfc_main$6 } from "./VField.3e3f434e.js";
import { _ as _sfc_main$8 } from "./VAvatar.e217127b.js";
import { _ as _export_sfc, u as useUserSession, c as useNotyf } from "./index.810ffa2d.js";
import { o as openBlock, g as createElementBlock, p as createBaseVNode, d as defineComponent, r as ref, Y as reactive, b as computed, a4 as watch, G as onMounted, s as createVNode, f as unref, t as withCtx, v as withDirectives, ag as vModelText, x as vModelCheckbox, i as normalizeClass, B as toDisplayString, F as Fragment, Z as renderList, av as TransitionGroup, _ as createCommentVNode, E as useHead } from "./vendor.07f7b9b8.js";
import { u as useProductSession } from "./masterService.5586de38.js";
import { p as pageTitle } from "./navbarLayoutState.990ce3dc.js";
import "./VModal.05bf9bc5.js";
import "./VLoader.26886e01.js";
import "./mesaService.f6f03d4a.js";
import "./VIconButton.6b5a741d.js";
import "./config.16ad6743.js";
const _sfc_main$2 = {};
const _hoisted_1$2 = /* @__PURE__ */ createBaseVNode("h5", null, null, -1);
const _hoisted_2$1 = [
  _hoisted_1$2
];
function _sfc_render(_ctx, _cache) {
  return openBlock(), createElementBlock("div", null, _hoisted_2$1);
}
var __unplugin_components_8 = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render]]);
var PosRestaurant_vue_vue_type_style_index_0_lang = "";
const _hoisted_1$1 = { class: "food-delivery-dashboard" };
const _hoisted_2 = { class: "left" };
const _hoisted_3 = { class: "left-body" };
const _hoisted_4 = { class: "restaurants" };
const _hoisted_5 = { class: "columns is-multiline is-mobile" };
const _hoisted_6 = {
  class: "column is-12 category-content",
  style: { "padding-bottom": "0px" }
};
const _hoisted_7 = { class: "pt-5 searchCategory-content columns" };
const _hoisted_8 = /* @__PURE__ */ createBaseVNode("img", {
  src: _imports_0,
  alt: "Buscar",
  class: "search-icon"
}, null, -1);
const _hoisted_9 = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 14 14"
};
const _hoisted_10 = ["stroke"];
const _hoisted_11 = { class: "tooltip-text" };
const _hoisted_12 = { class: "column is-2 px-0" };
const _hoisted_13 = { class: "tabs-wrapper" };
const _hoisted_14 = { class: "tabs-inner" };
const _hoisted_15 = { class: "tabs tabs-list tabs-list-pos is-centered mb-1" };
const _hoisted_16 = {
  style: { "border": "none" },
  class: "m-0"
};
const _hoisted_17 = /* @__PURE__ */ createBaseVNode("span", null, [
  /* @__PURE__ */ createBaseVNode("i", {
    "aria-hidden": "true",
    class: "iconify",
    "data-icon": "feather:grid"
  })
], -1);
const _hoisted_18 = [
  _hoisted_17
];
const _hoisted_19 = /* @__PURE__ */ createBaseVNode("span", null, [
  /* @__PURE__ */ createBaseVNode("i", {
    "aria-hidden": "true",
    class: "iconify",
    "data-icon": "feather:list"
  })
], -1);
const _hoisted_20 = [
  _hoisted_19
];
const _hoisted_21 = /* @__PURE__ */ createBaseVNode("li", { class: "tab-naver" }, null, -1);
const _hoisted_22 = {
  key: 0,
  class: "restaurants-list"
};
const _hoisted_23 = { class: "product-conteiner" };
const _hoisted_24 = {
  key: 1,
  style: { "padding-top": "1%" },
  class: "flex-table"
};
const _hoisted_25 = /* @__PURE__ */ createBaseVNode("div", { class: "flex-table-header" }, [
  /* @__PURE__ */ createBaseVNode("span", { class: "is-grow" }, "Producto"),
  /* @__PURE__ */ createBaseVNode("span", null, "Codigo"),
  /* @__PURE__ */ createBaseVNode("span", { class: "cell-end" }, "Precio")
], -1);
const _hoisted_26 = { class: "flex-list-inner" };
const _hoisted_27 = ["onClick"];
const _hoisted_28 = { class: "flex-table-cell is-media is-grow" };
const _hoisted_29 = { class: "item-name dark-inverted" };
const _hoisted_30 = {
  class: "flex-table-cell",
  "data-th": "C\xF3digo"
};
const _hoisted_31 = { class: "light-text" };
const _hoisted_32 = {
  class: "flex-table-cell cell-end",
  "data-th": "Precio"
};
const _hoisted_33 = { class: "is-primary" };
const _hoisted_34 = /* @__PURE__ */ createBaseVNode("div", {
  class: "is-hidden-desktop",
  style: { "min-height": "150px" }
}, null, -1);
const _hoisted_35 = {
  key: 0,
  class: "is-hidden-desktop cart-bottom-fixed h-hidden-tablet-l"
};
const _hoisted_36 = { class: "columns is-mobile is-centered m-custom" };
const _hoisted_37 = { class: "column is-11" };
const _hoisted_38 = { class: "right fixed-parent is-hidden-mobile h-hidden-tablet-p only-pos" };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  setup(__props) {
    const userSession = useUserSession();
    const productSession = useProductSession();
    const notif = useNotyf();
    const textSearch = ref("");
    const searchByBarcode = ref(false);
    const bagStore = useBagStore();
    const isListItems = ref(false);
    const isBarcodeActive = ref(false);
    const tooltipMessage = ref("Activar b\xFAsqueda por c\xF3digo de barras");
    const chunks = ref([]);
    const chunkSize = 500;
    const posBag = reactive({
      products: [],
      total: 0,
      barman: userSession.name
    });
    const state = reactive({
      products: productSession.products,
      products_filter: productSession.products,
      openDialogDocument: false,
      loading: false,
      generatedDocument: false,
      sections: sectionsData,
      categories: productSession.categories
    });
    const productIndexByBarcode = new Map();
    const productIndexByInternalId = new Map();
    const filteredProducts = ref(state.products);
    state.products.forEach((product) => {
      if (product.barcode) {
        productIndexByBarcode.set(product.barcode, product);
      }
      if (product.internalId) {
        productIndexByInternalId.set(product.internalId.toLowerCase(), product);
      }
    });
    const clickAddProduct = (item) => {
      bagStore.addProduct(item);
    };
    const openDialogDocument = () => {
      if (bagStore.getProducts().length > 0) {
        posBag.products = bagStore.getProducts();
        posBag.total = bagStore.getTotal();
        state.openDialogDocument = true;
      }
    };
    const closeDialogDocument = () => {
      posBag.products = [];
      posBag.total = 0;
      posBag.enterAmount = 0;
      bagStore.reset();
      state.openDialogDocument = false;
    };
    let debounceTimeout = null;
    const debouncedSearch = (callback, delay = 70) => {
      if (debounceTimeout)
        clearTimeout(debounceTimeout);
      debounceTimeout = setTimeout(callback, delay);
    };
    let debounceTimeoutBarcode = null;
    const debouncedSearchBarcode = (callback, delay = 300) => {
      if (debounceTimeoutBarcode)
        clearTimeout(debounceTimeoutBarcode);
      debounceTimeoutBarcode = setTimeout(callback, delay);
    };
    const loadProducts = () => {
      const allProducts = state.products;
      chunks.value = [];
      for (let i = 0; i < allProducts.length; i += chunkSize) {
        chunks.value.push(allProducts.slice(i, i + chunkSize));
      }
    };
    const removeAccents = (name) => {
      return name ? name.normalize("NFD").replace(/[\u0300-\u036f]/g, "") : "";
    };
    const products_filter = computed(() => filteredProducts.value);
    watch(textSearch, () => {
      if (textSearch.value.length > 0) {
        if (searchByBarcode.value) {
          debouncedSearchBarcode(() => {
            const itemFound = productIndexByBarcode.get(textSearch.value);
            if (itemFound) {
              bagStore.addProduct(itemFound);
              notif.success("Producto a\xF1adido!");
            } else {
              notif.error("Producto no encontrado");
            }
            textSearch.value = "";
            filteredProducts.value = itemFound ? [itemFound] : [];
          });
        } else {
          debouncedSearch(() => {
            const lowerSearchText = textSearch.value.toLowerCase();
            filteredProducts.value = chunks.value.flatMap((chunk) => chunk.filter((item) => {
              var _a;
              return removeAccents(item.name || "").toLowerCase().includes(removeAccents(lowerSearchText)) || productIndexByInternalId.has(lowerSearchText) && ((_a = productIndexByInternalId.get(lowerSearchText)) == null ? void 0 : _a.internalId) === item.internalId;
            }));
          });
        }
      } else {
        filteredProducts.value = state.products.length >= 500 ? state.products.slice(0, 500) : state.products;
      }
    });
    const back = () => {
      console.log("back");
      state.openDialogDocument = false;
    };
    const selectCategory = (id) => {
      if (id === 0) {
        filteredProducts.value = state.products_filter;
      } else {
        filteredProducts.value = state.products_filter.filter((x) => x.categoryId === id);
      }
    };
    const changeSearchByBarcode = () => {
      isBarcodeActive.value = !isBarcodeActive.value;
      tooltipMessage.value = isBarcodeActive.value ? "Desactivar b\xFAsqueda por c\xF3digo de barras" : "Activar b\xFAsqueda por c\xF3digo de barras";
      let byBarcode = searchByBarcode.value ? 1 : 0;
      userSession.setSearchByBarcode(byBarcode);
    };
    onMounted(() => {
      searchByBarcode.value = userSession.searchByBarcode ? true : false;
      isBarcodeActive.value = userSession.searchByBarcode ? true : false;
      const searchCategoryContent = document.querySelector(".searchCategory-content");
      const categoryContent = document.querySelector(".category-content");
      if (!searchCategoryContent || !categoryContent)
        return;
      const offsetTop = searchCategoryContent.offsetTop;
      const handleScroll = () => {
        const shouldStick = window.scrollY >= offsetTop;
        searchCategoryContent.classList.toggle("is-sticky", shouldStick);
        if (shouldStick) {
          categoryContent.style.marginBottom = "90px";
        } else {
          categoryContent.style.marginBottom = "0";
        }
      };
      window.addEventListener("scroll", handleScroll);
      loadProducts();
    });
    return (_ctx, _cache) => {
      const _component_CashDialog = _sfc_main$3;
      const _component_DocumentDialog = _sfc_main$4;
      const _component_CategoriesNavBar = _sfc_main$5;
      const _component_VControl = __unplugin_components_1;
      const _component_VField = _sfc_main$6;
      const _component_ProductPos = _sfc_main$7;
      const _component_VAvatar = _sfc_main$8;
      const _component_CartMobile = _sfc_main$9;
      const _component_Cart = __unplugin_components_8;
      const _component_Bag = _sfc_main$a;
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_component_CashDialog),
        createVNode(_component_DocumentDialog, {
          "pos-bag": unref(posBag),
          open: unref(state).openDialogDocument,
          onClose: closeDialogDocument,
          onBack: back
        }, null, 8, ["pos-bag", "open"]),
        createBaseVNode("div", _hoisted_1$1, [
          createBaseVNode("div", _hoisted_2, [
            createBaseVNode("div", _hoisted_3, [
              createBaseVNode("div", _hoisted_4, [
                createBaseVNode("div", _hoisted_5, [
                  createBaseVNode("div", _hoisted_6, [
                    createVNode(_component_CategoriesNavBar, { onSelectcategory: selectCategory })
                  ]),
                  createBaseVNode("div", _hoisted_7, [
                    createVNode(_component_VField, { class: "search-conteiner column is-10" }, {
                      default: withCtx(() => [
                        createVNode(_component_VControl, { class: "input-container" }, {
                          default: withCtx(() => [
                            _hoisted_8,
                            withDirectives(createBaseVNode("input", {
                              "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => textSearch.value = $event),
                              type: "text",
                              class: "input input-search-pos is-rounded",
                              placeholder: "Busca un producto ..."
                            }, null, 512), [
                              [vModelText, textSearch.value]
                            ]),
                            createBaseVNode("label", null, [
                              withDirectives(createBaseVNode("input", {
                                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => searchByBarcode.value = $event),
                                class: "barcode-toggle",
                                type: "checkbox",
                                onChange: changeSearchByBarcode
                              }, null, 544), [
                                [vModelCheckbox, searchByBarcode.value]
                              ]),
                              createBaseVNode("span", {
                                class: normalizeClass(["barcode-icon", { active: isBarcodeActive.value }])
                              }, [
                                (openBlock(), createElementBlock("svg", _hoisted_9, [
                                  createBaseVNode("path", {
                                    fill: "none",
                                    stroke: isBarcodeActive.value ? "#4caf50" : "#cfcfcf",
                                    "stroke-linecap": "round",
                                    "stroke-linejoin": "round",
                                    d: "M5.11.656H1.208a.49.49 0 0 0-.488.488v3.904m12.686 0V1.144a.49.49 0 0 0-.488-.488H9.014m0 12.688h3.904a.49.49 0 0 0 .488-.488V8.952m-12.687 0v3.904a.49.49 0 0 0 .488.488H5.11m5.696-9.552v6.416M3.194 3.792v6.416m5.709-6.416v4.666m0 1.75v-.291M7 3.792v4.666m0 1.75v-.291M5.097 3.792v4.666m0 1.75v-.291"
                                  }, null, 8, _hoisted_10)
                                ]))
                              ], 2),
                              createBaseVNode("span", _hoisted_11, toDisplayString(tooltipMessage.value), 1)
                            ])
                          ]),
                          _: 1
                        })
                      ]),
                      _: 1
                    }),
                    createBaseVNode("div", _hoisted_12, [
                      createBaseVNode("div", _hoisted_13, [
                        createBaseVNode("div", _hoisted_14, [
                          createBaseVNode("div", _hoisted_15, [
                            createBaseVNode("ul", _hoisted_16, [
                              createBaseVNode("li", {
                                class: normalizeClass([isListItems.value == false && "is-active"])
                              }, [
                                createBaseVNode("a", {
                                  onClick: _cache[2] || (_cache[2] = ($event) => isListItems.value = false)
                                }, _hoisted_18)
                              ], 2),
                              createBaseVNode("li", {
                                class: normalizeClass([isListItems.value == true && "is-active"])
                              }, [
                                createBaseVNode("a", {
                                  onClick: _cache[3] || (_cache[3] = ($event) => isListItems.value = true)
                                }, _hoisted_20)
                              ], 2),
                              _hoisted_21
                            ])
                          ])
                        ])
                      ])
                    ])
                  ])
                ]),
                !isListItems.value ? (openBlock(), createElementBlock("div", _hoisted_22, [
                  createBaseVNode("div", _hoisted_23, [
                    (openBlock(true), createElementBlock(Fragment, null, renderList(unref(products_filter), (product) => {
                      return openBlock(), createElementBlock("div", {
                        key: product.id
                      }, [
                        createVNode(_component_ProductPos, {
                          product,
                          onClickAddProduct: clickAddProduct
                        }, null, 8, ["product"])
                      ]);
                    }), 128))
                  ])
                ])) : (openBlock(), createElementBlock("div", _hoisted_24, [
                  _hoisted_25,
                  createBaseVNode("div", _hoisted_26, [
                    createVNode(TransitionGroup, {
                      name: "list",
                      tag: "div"
                    }, {
                      default: withCtx(() => [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(products_filter), (item) => {
                          return openBlock(), createElementBlock("div", {
                            key: item.id,
                            class: "flex-table-item restaurants-list-item",
                            style: { "cursor": "pointer" },
                            onClick: ($event) => clickAddProduct(item)
                          }, [
                            createBaseVNode("div", _hoisted_28, [
                              createVNode(_component_VAvatar, {
                                picture: item.imageUrl,
                                size: "medium"
                              }, null, 8, ["picture"]),
                              createBaseVNode("div", null, [
                                createBaseVNode("span", _hoisted_29, toDisplayString(item.name), 1)
                              ])
                            ]),
                            createBaseVNode("div", _hoisted_30, [
                              createBaseVNode("span", _hoisted_31, toDisplayString(item.internalId), 1)
                            ]),
                            createBaseVNode("div", _hoisted_32, [
                              createBaseVNode("span", _hoisted_33, toDisplayString(item.currencyTypeSymbol) + " " + toDisplayString(item.price.toFixed(2)), 1)
                            ])
                          ], 8, _hoisted_27);
                        }), 128))
                      ]),
                      _: 1
                    })
                  ])
                ]))
              ])
            ]),
            _hoisted_34
          ]),
          unref(bagStore).getProducts().length > 0 ? (openBlock(), createElementBlock("div", _hoisted_35, [
            createBaseVNode("div", _hoisted_36, [
              createBaseVNode("div", _hoisted_37, [
                createVNode(_component_CartMobile, { onFinalizeSale: openDialogDocument }),
                createVNode(_component_Cart)
              ])
            ])
          ])) : createCommentVNode("", true),
          createBaseVNode("div", _hoisted_38, [
            createVNode(_component_Bag, { onFinalizeSale: openDialogDocument })
          ])
        ])
      ], 64);
    };
  }
});
const _hoisted_1 = { class: "page-content-inner" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  setup(__props) {
    useHead({
      title: pageTitle
    });
    return (_ctx, _cache) => {
      const _component_LockedScreen = _sfc_main$b;
      const _component_PosRestaurant = _sfc_main$1;
      return openBlock(), createElementBlock("div", _hoisted_1, [
        createVNode(_component_LockedScreen),
        createVNode(_component_PosRestaurant)
      ]);
    };
  }
});
export { _sfc_main as default };
